/* 
 *  Stratégies Numériques
 *  http://www.strat-num.fr/dr2d/
 *  
 */

"use strict";

// First, checks if it isn't implemented yet.
if (!String.prototype.format) {
  String.prototype.format = function() {
    var args = arguments;
    return this.replace(/{(\d+)}/g, function(match, number) { 
      return typeof args[number] !== 'undefined'
        ? args[number]
        : match
      ;
    });
  };
}
if (!Element.prototype.addClassName) {
  Element.prototype.addClassName = function(className) {
    this.removeClassName(className);
    this.className += " " + className;
  }; 
}
if (!Element.prototype.removeClassName) {
  Element.prototype.removeClassName = function(className) {
    this.className = this.className.replace(" "+className,"");
    this.className = this.className.replace(className,"");
  }; 
}





var menuItemDisconnect = null;
var btTabRegistration = null;
var tabRegistration = null;


var SlideT = {
    WaitNext:0,
    Connection:1, 
    //Registration:1, 
    PlayerFeatures:2,   //> Avatar 
    StartLocation:3,    //> Loc
    RequireCartouche:4, //> Jeu
    QuestAchieved:5     //> Fin de partie
};

function writeToLog(o1){
  console.log(o1);
};
    
function slideTo(slide)
{
    var cons = document.getElementById("Console");
    if(slide === SlideT.Connection){
        cons.addClassName("slideConnection");
    }else{
        cons.removeClassName("slideConnection");
    }
    if(slide === SlideT.StartLocation){
        cons.addClassName("slideStartLocation");
    }else{
        cons.removeClassName("slideStartLocation");
    }
    if(slide === SlideT.PlayerFeatures){
        cons.addClassName("slidePlayerFeatures");
    }else{
        cons.removeClassName("slidePlayerFeatures");
    }
    if(slide === SlideT.RequireCartouche){
        cons.addClassName("slideRequireCartouche");
    }else{
        cons.removeClassName("slideRequireCartouche");
    }
    if(slide === SlideT.WaitNext){
        cons.addClassName("slideWaitNext");
    }else{
        cons.removeClassName("slideWaitNext");
    }
    if(slide === SlideT.QuestAchieved){
        cons.addClassName("slideQuestAchieved");
    }else{
        cons.removeClassName("slideQuestAchieved");
    }
    
    
//    { // DEBUG
//        cons.addClassName("slideConnection");
//        cons.addClassName("slidePlayerFeatures");
//        cons.addClassName("slideRequireCartouche");
//    }
};

function performConnect(wsUri){
    DR2D_WSAPI.host = wsUri;
    DR2D_WSAPI.connect();
};
function performDisconnect(){
    DR2D_WSAPI.disconnect();
};

function waitForNextStep(currentSeq)
{
  //SN_DR2D.CurrentStep = SN_DR2D.GameStep.NoGame;
  WaitNext_setHtmlMessage(
       "Séquence '"+currentSeq+"'...<br>"
      +"Veuillez patienter le temps que vos concurents fassent de même.");
  slideTo(SlideT.WaitNext);
};
function waitForPlayerFeatures()
{
  //SN_DR2D.CurrentStep = SN_DR2D.GameStep.NoGame;
  WaitNext_setHtmlMessage(
       "Vous êtes maintenant connecté au serveur de jeu.<br>"
      +"Veuillez patienter le temps que vos concurents fassent de même.");
  slideTo(SlideT.WaitNext);
};
function waitForPlayerLocation()
{
  WaitNext_setHtmlMessage(
       "Vous êtes maintenant déclaré.<br>"
      +"Veuillez patienter le temps que vos concurents fassent de même.");
  slideTo(SlideT.WaitNext);
};
function waitForRequireCartouche()
{
  //SN_DR2D.CurrentStep = SN_DR2D.GameStep.NoGame;
  WaitNext_setHtmlMessage(
       "Vous êtes maintenant placé sur le plateau.<br>"
      +"Veuillez patienter le temps que vos concurents fassent de même.");
  slideTo(SlideT.WaitNext);
};
function waitForRequireCartouche2()
{
  //SN_DR2D.CurrentStep = SN_DR2D.GameStep.NoGame;
  WaitNext_setHtmlMessage(
       "Vous avez donné vos directives.<br>"
      +"Veuillez patienter le temps que vos concurents fassent de même.");
  slideTo(SlideT.WaitNext);
};

var gameContext = { 
    mcndId:null, 
    questAchieved:false,
    reset: function(){this.mcndId=null; this.questAchieved=false;}.bind(this) 
};

//> like window.onload =init;
function init() {
    
    /* All Pages */
    menuItemDisconnect = document.getElementById("menuItemDisconnect");
    btTabRegistration = document.getElementById("btTabRegistration");
    tabRegistration = document.getElementById("PlayerRegistration");

    DR2D_WSAPI.onWsOpen = function (evt) {
        toogle(true);
        writeToLog(">>>>> connected!");
        DR2D_WSAPI.sendSms1("Bonjour!");
        gameContext.reset();
        waitForPlayerFeatures();
    };
    
    DR2D_WSAPI.onWsMessage= function (evt) {
        writeToLog('>>>>>' + evt.data );
        try{
          var msgBulk = JSON.parse(evt.data);
          if(msgBulk.ShortMessageService){
              writeToLog(msgBulk.ShortMessageService.msgCode);
              writeToLog(msgBulk.ShortMessageService.msgDesc);
          }
          else if(msgBulk.stgyCall){
              if(msgBulk.stgyCall.seq ==="InitDeclareBoard"){
                // pour récupérer la taille du/des plateaux
                var width = msgBulk.stgyCall.argsIn.board.boardWidth;
                var height = msgBulk.stgyCall.argsIn.board.boardHeight;
                gameContext.boardSize = {
                    width  : width, 
                    height : height
                };
                gameContext.board = {
                    size : {width  : width, height : height},
                    lagX : Math.floor((12 - width)/2),  // décalage en X depuis bord ouest
                    lagY : Math.floor((12 - height)/2)  // décalage en Y depuis bord nord
                };
 
                //PlayerFeatures_InitDeclareBoard(msgBulk);
                waitForNextStep(msgBulk.stgyCall.seq);
                _onReply(msgBulk);
              }
              else if(msgBulk.stgyCall.seq ==="InitPlayerFeatures"){
                slideTo(SlideT.PlayerFeatures);
                PlayerFeatures_InitPlayerFeatures(msgBulk);
                gameContext.mcndId = msgBulk.stgyCall.argsIn.mcndId;
              }
              else if(msgBulk.stgyCall.seq ==="InitPlayerLocalization"){
                slideTo(SlideT.StartLocation);
                PlayerFeatures_InitPlayerLocalization(msgBulk);
              }
              else if(msgBulk.stgyCall.seq ==="RoundRequireCartouche"){
                slideTo(SlideT.RequireCartouche);
                RequireCartouche_RoundRequireCartouche(msgBulk);
              }
              else if(msgBulk.stgyCall.seq ==="QuestAchieved"){
                var completed = msgBulk.stgyCall.argsIn.completed;
                if(completed.indexOf(gameContext.mcndId) !== -1)
                {  
                   gameContext.questAchieved = true;
                   slideTo(SlideT.QuestAchieved); // vous avez terminé !
                }
                _onReply(msgBulk);
              }
              else if(msgBulk.stgyCall.seq ==="GameFinalisation"){
                _onReply(msgBulk);
                //DR2D_WSAPI.disconnect();
              }
              else{ // réponse par défaut
                if(!gameContext.questAchieved)
                    waitForNextStep(msgBulk.stgyCall.seq);
                //
                _onReply(msgBulk);
              }
          } // ignore all the others
        }catch(ex)
        {
            writeToLog(ex);
        }
      };
      
    function _onReply(msgBulk)
    {
        var msgBulkReply = DR2D_WSAPI.extractReplyFromCall(msgBulk);
        DR2D_WSAPI.sendReply(msgBulkReply);
    }

    DR2D_WSAPI.onWsClose= function (evt) {
        toogle(false);
        writeToLog(">>>>> DISCONNECTED.");
        slideTo(SlideT.Connection);
      };
    DR2D_WSAPI.onWsError= function (evt) {
        writeToLog(">>>>>ERROR: " + evt);
      };

        
    
    if(menuItemDisconnect) 
        menuItemDisconnect.addEventListener("click", performDisconnect, false);
    
    
    WaitNext_init();
    Connection_init();
    PlayerFeatures_init();
    RequireCartouche_init();
    QuestAchieved_init();
    
    slideTo(SlideT.Connection);
    //window.addEventListener("keydown", checkKeyboard);
}

      
function checkKeyboard(myEvt) {
    if (myEvt.keyCode === 13) {
        ;
    }
}

function dragStart(ev) {
   ev.dataTransfer.effectAllowed='move';
   ev.dataTransfer.setData("Text", ev.target.getAttribute('id'));
   ev.dataTransfer.setDragImage(ev.target,ev.target.clientWidth/2,ev.target.clientHeight/2);
   return true;
}
function dragEnter(ev) {
   var srcId = ev.dataTransfer.getData("Text");
   if( srcId.substring(0, 3) === "Mvt") 
       ev.dataTransfer.dropEffect ='copy';
   if( srcId.substring(0, 3) === "Car")
       ev.dataTransfer.dropEffect ='none';
   //event.preventDefault();
   return true;
}
function dragOver(ev) {
    return false;
}
function dragDrop(ev) {
   var srcId = ev.dataTransfer.getData("Text");
   var srcElem = document.getElementById(srcId);
   var tgtElem = ev.target;
   var tgtId = tgtElem.id;
   if(srcId !== tgtId)
   {
        if( srcId.substring(0, 3) === "Mvt")
        { // set a 'NoMove'
            NoMove(srcElem);
        }else if(tgtId.substring(0, 3) === "Mvt") 
        { // add and action
            tgtElem.className = srcElem.id;
            tgtElem.firstChild.textContent = ".";
        }
   }else if( srcId.substring(0, 4) === "Cart")
   { // clear all entries
       var children = [].slice.call(tgtElem.children);
       children.forEach(function(el) { NoMove(el); });
   }
   ev.stopPropagation();
   return false;
}

function NoMove(elem)
{
    elem.className ="Move_None";
    elem.firstChild.textContent = elem.idx;
}
